/*--------------------------------------------------------------------- NVMH5 -|----------------------
Path:  Sdk\Demos\Direct3D9\src\AntiAliasingWithPostProcessing\
File:  AAPPScene.h

Copyright NVIDIA Corporation 2003
TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED *AS IS* AND NVIDIA AND
AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL NVIDIA
OR ITS SUPPLIERS BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES WHATSOEVER
INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION, LOSS OF
BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS) ARISING OUT OF THE USE OF OR INABILITY TO USE THIS
SOFTWARE, EVEN IF NVIDIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


Comments:


-------------------------------------------------------------------------------|--------------------*/

#ifndef H_AAPPSCENE_H
#define H_AAPPSCENE_H

#include "NV_D3DMesh\NV_D3DMesh.h"

class AAPPScene
{
public:
	IDirect3DDevice9 *	m_pD3DDev;
	MeshVB				m_CenterPinwheel;
	MeshVB				m_OuterRing;
	D3DXMATRIX			m_matInnerRing;

	HRESULT		Free();
	HRESULT		Initialize( IDirect3DDevice9 * pDev );
	HRESULT		CreatePinwheel( MeshVB * pMeshVB, int num_fins, float inner_radius, float radius );
	HRESULT		CreateOuterRing( MeshVB * pMeshVB, int num_segments, float frac_gap, float inner_radius, float outer_radius );
	void		Animate( float fCurrentTimeInSeconds );

	AAPPScene();
	~AAPPScene();
	void SetAllNull()
	{
		m_pD3DDev	= NULL;
	}
};

#endif
